SHEBANG
# Copyright (C)2002..2022 @BABOLO http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up-anon.m4,v 1.2 2022/03/07 16:46:48 babolo Exp $

JNTROSTUP(ftpd,-anon,ftpddnl
,dnl
# jailup ${inclass}${suffix} dir jailname jailaddr [user [group [port]]]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# system /usr/libexec/ftpd
#                                                   useddnl
)

TEMPLATE=${this}/template${suffix}
jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user="${4:-root}"
group="${5:-ftp}"
port="${6:-21}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY(host.conf hosts protocols resolv.conf)

${up_genlist} libexec/ ${MTREE} | ${up_libexe} "${main_dir}/libexec/"
${up_genlist} libexec/ ${MTREE} | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####

${sed} -e "s|%%PORT%%|${port}|"\
       -e "s|%%GROUP%%|${group}|"\
       -e "s|%%USER%%|${user}|" "${TEMPLATE}" | ${up_ponf} "${conf_dir}/xinetd"

${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:
	ftp:*:14:
	nogroup:*:65533:
	nobody:*:65534:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	ftp:*:14:14::0:0:Anonymous FTP Admin:/var/ftp:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
EOF

${up_adc} "${etcdir}/newsyslog.conf" <<- EOF
	#${main_dir}/var/log/ftpd 	644  9     *	@01T00
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${touch} "${main_dir}/var/log/ftpd"
${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0755
    group
    host.conf
    hosts
    localtime
    protocols
    resolv.conf
    master.passwd		mode=0600
    master.template		mode=0600
    xinetd
..
EOF
${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"

${up_adc} "${JAILUPRC}" <<- EOF
	#${genclass}	xinetd	${jdir}	${jailsname}	${jailsaddr}	0	0	0	xinetd
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev	devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc	nullfs	ro,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
