SHEBANG
# Copyright (C)2004..2022 @BABOLO http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up-link.m4,v 1.11 2022/03/07 16:46:49 babolo Exp $

JNTROSTUP(sshd,-link,sshd,dnl
# jailup sshd-link dir jailname jailaddr user[/uid] local_port:host:remote_port [login@]host [port]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# system ssh
#                                                   useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user="${4%/*}"
group="${user}"
uid=${4#${user}}
uid=${uid#/}
uid=${uid:-65537}
link="${5}"
rhost="${6}"
port="${7:-22}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${mkdir} "${main_dir}" "${conf_dir}/ssh" "${conf_dir}/home/${user}/.ssh"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY(host.conf hosts protocols resolv.conf ssh/moduli)
${up_ldsh} << EOF | ${up_shlib} "${main_dir}/lib"
    /usr/bin/ssh
EOF

${up_libexe} "${main_dir}/libexec" << EOF
    ld-elf.so.1
    ssh
EOF

${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:
	nogroup:*:65533:
	nobody:*:65534:
	${user}:*:${uid}:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
	${user}:*:${uid}:${uid}::0:0:User:/etc/home/${user}:/dev/null/none
EOF

cf="ssh_config"; if  [ -e "${conf_dir}/ssh/${cf}" ]; then cf="${cf}.sample"; fi
${cp} "${TEMPLATE}-link" "${conf_dir}/ssh/${cf}"

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
[ ! -e "${conf_dir}/home/${user}/.ssh/identity"   ] && ${keygen} -t rsa1    -N "" -f "${conf_dir}/home/${user}/.ssh/identity"   || :
[ ! -e "${conf_dir}/home/${user}/.ssh/id_rsa"     ] && ${keygen} -t rsa     -N "" -f "${conf_dir}/home/${user}/.ssh/id_rsa"     || :
[ ! -e "${conf_dir}/home/${user}/.ssh/id_dsa"     ] && ${keygen} -t dsa     -N "" -f "${conf_dir}/home/${user}/.ssh/id_dsa"     || :
[ ! -e "${conf_dir}/home/${user}/.ssh/id_ecdsa"   ] && ${keygen} -t ecdsa   -N "" -f "${conf_dir}/home/${user}/.ssh/id_ecdsa"   || :
[ ! -e "${conf_dir}/home/${user}/.ssh/id_ed25519" ] && ${keygen} -t ed25519 -N "" -f "${conf_dir}/home/${user}/.ssh/id_ed25519" || :
${mtree} -Ueqxp "${conf_dir}" << EOF
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0755
    group
    host.conf
    hosts
    localtime
    protocols
    resolv.conf
    master.passwd	mode=0600
/set type=dir mode=0755
    ssh
        moduli		type=file mode=0644
        ssh_config	type=file mode=0644
    ..
    home
/set uid=${uid}
        ${user}
            .ssh
/set type=file mode=0444
                identity.pub
                id_rsa.pub
                id_dsa.pub
                id_ecdsa.pub
                id_ed25519.pub
/set mode=0400
                identity
                id_rsa
                id_dsa
                id_ecdsa
                id_ed25519
            ..
        ..
    ..
..
EOF

${up_adc} "${JAILUPRC}" <<- EOF
#link	${genclass}${suffix}	${jdir}	${jailsname}	${jailsaddr}	0	${uid}	${uid} ${link} ${rhost} ${port} 2
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev	devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc	nullfs	ro,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
